<template>
    <div class="">
            <page-header title="Dépenses">
              <div slot="nav">
                <div class=" drowpdown mr-3">
                    <button class="btn btn-secondary dropdown-toggle" type="button" id="dropdownMenuButton" data-toggle="dropdown" aria-haspopup="true" aria-expanded="false">
                        <i class="fas fa-plus-circle mr-3"></i>Exporter vers
                    </button>
                    <div class="dropdown-menu" aria-labelledby="dropdownMenuButton">
                          <a :href="excelUrl"  class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-excel t-plus-1 text-success fa-fw fa-lg "></i> EXCEL</a>
                          <a href="javascript:;" class=" dropdown-item btn btn-sm btn-white m-b-10"><i class="fa fa-file-pdf t-plus-1 text-danger fa-fw fa-lg "></i> PDF</a>
                    </div>
                    </div>
              </div>
            </page-header>
            <div class="col-md-12">
              <div :class="['card bg-transparent']" >
               <div :class="['card-header pl-0']">
                    <h3 class="card-title mb-0">
                        <button @click="showModalOnCreate"  class="ml-4 btn btn-xs btn-secondary text-xs"> 
                           <i class="fas fa-plus-circle right"></i>  Nouvelle dépense
                        </button>
                    </h3>

                    <div class="card-tools d-flex">
                         <filter-bar ref="filterBar"></filter-bar>
                    </div>
              </div>
              <!-- /.card-header -->
              <div class="card-body table-responsive  p-0 position-relative " v-show="!NoDataForSearch && !NoDataAtAll" >
                    <vuetable :css="table" ref="vuetable" api-url="api/depenses" :fields="columns" 
                           pagination-path=""
                           :per-page="15"
                           @vuetable:loading="onLoading" 
                           @vuetable:loaded="onLoadingDone"
                           :append-params="moreParams" 
                           :http-options="httpOptions"
                           detail-row-component="mdetail-row-depenses-for-mobile"
                           @vuetable:pagination-data="onPaginationData">
                            <template slot="description" slot-scope="props">   
                              {{ props.rowData.description}}
                            </template>
                          <template slot="montant" slot-scope="props">   
                                 {{ monnaie(props.rowData.montant) }} <span>F cfa</span>
                          </template>
                           <template slot="facturation" slot-scope="props">   
                                 {{ props.rowData.date_facturation | toDate }} 

                            </template>
                          <template slot="depense" slot-scope="props">   
                                 {{ props.rowData.type_depense != null ? props.rowData.type_depense.libelle  :"Inconnu" }} 

                            </template>
                            <template slot="vehicule" slot-scope="props">   
                                 {{ props.rowData.vehicule != null ? props.rowData.vehicule.title  :"Inconnu" }} 
                            </template>
                            
                            <template slot="date_created" slot-scope="props">   
                                 {{ props.rowData.created_at | toDateTime }} 

                            </template>
                            <template slot="actions" slot-scope="props">   
                              <div class="custom-actions">
                                  <button class="btn btn-xs btn-secondary"
                                  @click="showModalOnEdit(props.rowData)">
                                  <i class="fas fa-edit"></i>
                                  </button>
                                  <button class="btn btn-xs btn-danger"
                                  @click="remove(props.rowData.id)">
                                  <i class="fas fa-trash"></i>
                                  </button>
                              </div>
                            </template>
                    </vuetable>
              </div>
              <pa ref="pagination" :is-loading="isLoading"  :pager="[15,25,50,100]" @vuetable-pagination:change-page="onChangePage" v-show="!NoDataForSearch && !NoDataAtAll"   ></pa>
              <!-- /.card-body -->
               </div>
               <no-data-in-search v-show="pageInit" :search="searchTxt" :show="NoDataForSearch" :data-empty="NoDataAtAll"></no-data-in-search>
              <!-- Modal dbt -->
               <crud-depense @add-depense-event="apresAjoutDepense" @update-depense-event="apresModificationDepense"></crud-depense>
            <!-- Modal fin -->
</div>
    </div>
</template>

<script>

   import  Vuetable from "vuetable-2/src/components/Vuetable";
   import pa from './../../components/pagination/Pagination'
    import CrudDepense from './../../components/depenses/CrudDepense'
   import Form from "./../../classes/Form"
   import Master from "./../Master.vue";


    export default {
        mixins: [Master],
        data(){
            return{
                modeEdit:false,
                ftime:true,
                hasData:false,
                vehicule :"",
                tdepense :"",
                options:
                {
                  vehicules:[],
                  tdepenses:[]
                },
                form : new Form(
                  {
                    description:"",
                    montant:'',
                    vehicule_id:"",
                    type_depense_id:""
                }),
                moreParams:{},
                isLoading:false,
                columns : [
                 {
                name: '__slot:facturation',   // <----
                title: "Date de Facturation",
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                }, 
                {
                name: '__slot:description',   // <----
                title: "Description",

                },
                {
                name: '__slot:montant',   // <----
                title: "Montant",
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                },  
  
                {
                name: '__slot:vehicule',   // <----
                title: "Véhicule",

                },
                {
                name: '__slot:depense',   // <----
                title: "Type de dépense",
                },
                {
                name: '__slot:date_created',   // <----
                title: "Date d'enregistrement",
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                },
                {
                name: '__slot:actions',   // <----
                title: 'Actions',
                titleClass: 'center aligned',
                dataClass: 'center aligned'
                }
                ],
                  table: {
                    tableWrapper: '',
                    tableHeaderClass: 'mb-0',
                    tableBodyClass: 'mb-0',
                    tableClass: 'table table-striped table-hover',
                    ascendingIcon: 'fa fa-chevron-up',
                    descendingIcon: 'fa fa-chevron-down',
                    ascendingClass: 'sorted-asc',
                    descendingClass: 'sorted-desc',
                    sortableIcon: 'fa fa-sort',
                    detailRowClass: 'vuetable-detail-row',
                    handleIcon: 'fa fa-bars text-secondary',
                    renderIcon(classes, options) {
                      return `<i class="${classes.join(' ')}"></span>`
                    }
                  }
            }
        },
        created()
        {
          this.modeEdit = false
 
        },
        mounted() {
                this.$events.$on('filter-set', eventData => this.onFilterSet(eventData))
                this.$events.$on('filter-reset', e => this.onFilterReset())
        },
        computed:
        {
            ModalTitle ()
            {
              return  this.modeEdit ? " Modification d'une dépense"  : " Ajout d'une dépense"
            },
            ModalAction ()
            {
              return  this.modeEdit ? " Modifier"  : " Ajouter"
            },
            shouldGoToFirstPage()
            {
              if(this.$refs.vuetable)
              {
                return (this.$refs.vuetable.tableData.length) - 1 == 0
              } 
              else
              {
                return false
              }
            },
            filterBarIsFilled()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter != "" ? true : false
                else
                 return false
            },
            searchTxt()
            {
                if(this.moreParams.hasOwnProperty('filter'))
                  return this.moreParams.filter
                else
                 return ""
            },
            NoDataForSearch()
            {

              return (this.hasData == false && this.filterBarIsFilled == true ) ? true : false
            
            },

            NoDataAtAll()
            {

              return (this.hasData == false && this.filterBarIsFilled == false ) ? true : false
            
            },
            excelUrl()
           {
             return '/depenses/export?format=excel&q='+this.searchTxt
           },
           pdfUrl()
           {
             return '/depenses/export?format=pdf&q='+this.searchTxt
           },
        },
        methods: 
        {
            formatDate: function(value, fmt) 
            {
               return  toDateFormat(value, fmt)
            },
            //Recupere le libellé d'un role
            getRole(value)
            {
               var elem = this.$refs.vuetable.tableData.find( e => e.vehicule_id == value);
               if(elem.role!=null)
                 return elem.role.libelle
               else
                 return "-"
            },
            onPaginationData (paginationData) 
            {
              console.log(paginationData.data)
              if(this.pageInit==false)
                 this.pageInit =true
              else
              {
                
              }
              this.hasData = paginationData.data.length > 0
              this.$refs.pagination.setPaginationData(paginationData)
            },
            onChangePage (page) 
            {
               
               this.$refs.vuetable.changePage(page)
            },
            onLoading() 
            {

               this.isLoading = true
                if(this.ftime==false)
                {
                    $('table.vuetable').block({ 
                        message: '<div class="blockui"><span>Patientez svp</span><span><div class="kt-spinner kt-spinner--v2 kt-spinner--danger "></div></span></div>', 
                        css: { border: 'none' },
                                                
                            // styles for the overlay 
                            overlayCSS:  { 
                                backgroundColor: '#000', 
                                opacity:         0.06, 
                                cursor:          'wait' 
                            },
                    }); 
                    
                }
                this.ftime = false
            },
            onLoadingDone() 
            {
               this.isLoading = false
                if(this.ftime==false)
                {
                    $('table.vuetable').unblock()
                }
            },

            onFilterSet (filterText) {
                this.moreParams = {
                    'filter': filterText
                }
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            onFilterReset () {
                this.moreParams = {}
                Vue.nextTick( () => this.$refs.vuetable.refresh())
            },
            //Retire un role de la BDD
             remove(e)
             {
                 
                  
                  //On demande la confirmation de la suppression
                    alertConfirm("Voulez-vous supprimer cette dépense ?","Suppréssion d'une dépense")
                    .then(result => {
                        //On réinitialise le chargement
                        this.isLoading = true
                        if(result)
                        {
                           axios.delete("api/depenses/"+e).then((response) => 
                            { 
                              
                                  // on rafraichit la page de donnée actuelle
                                  !this.shouldGoToFirstPage ? this.$refs.vuetable.reload() : this.$refs.vuetable.refresh()
                                  //on notifie l'effectivité de la suppréssion
                                  flash("<span>Supprimé <strong>avec succès</strong></span>")
                                  //On réinitialise le chargement
                                  this.isLoading = false
                            },
                            (error) =>
                            {
                              this.isLoading = false
                            });
                        }
                    })
                    .catch(error => {
                        reject(error);
                    });
             },
            //Ajoute un role dans la BDD
            apresAjoutDepense()
            {
                  this.$refs.vuetable.refresh()
            },
            //Actualise  un role dans la BDD
            apresModificationDepense()
            {
              
              this.$refs.vuetable.reload()
                                
            },
            //On affiche le modal pour la création
            showModalOnCreate()
            {
    
                window.event.$emit('show-modal-for-adding-depense')
              
            },
            //On affiche le modal pour l'édition
            showModalOnEdit(entity)
            {

                  window.event.$emit('show-modal-for-updating-depense',entity)
             },
              //Initialisation du formulaire
              reset()
             {
                  this.form.reset();
                  this.$refs['inputModal'].hide()
                  this.modeEdit = false
                  this.isLoading = false
                  if(this.moreParams.hasOwnProperty('filter'))
                  this.moreParams.filter=""
             }
              
        },
        components:
        {

            Vuetable,CrudDepense,
            pa
        }
    }
</script>